<?php

class fedexsmartpost {
 var $code, $title, $description, $icon, $enabled, $tax_class;

//Class Constructor
	function fedexsmartpost() {
		global $order, $customer_id, $db;
		 
		$this->code 			      = "fedexsmartpost";
		$this->title 			      = MODULE_SHIPPING_FEDEX_SMARTPOST_TEXT_TITLE;
		$this->description	    = MODULE_SHIPPING_FEDEX_SMARTPOST_TEXT_DESCRIPTION;
		$this->sort_order		    = MODULE_SHIPPING_FEDEX_SMARTPOST_SORT_ORDER;
		$this->icon             = DIR_WS_IMAGES . 'fedex-images/SMARTPOST.gif';
    $this->tax_class        = MODULE_SHIPPING_FEDEX_SMARTPOST_TAX_CLASS;
    if (zen_get_shipping_enabled($this->code)) {
      $this->enabled = ((MODULE_SHIPPING_FEDEX_SMARTPOST_STATUS == 'true') ? true : false);
    }
		$this->fedex_key		    = MODULE_SHIPPING_FEDEX_SMARTPOST_KEY;
		$this->fedex_pwd		    = MODULE_SHIPPING_FEDEX_SMARTPOST_PWD;
		$this->fedex_act_num	  = MODULE_SHIPPING_FEDEX_SMARTPOST_ACT_NUM;
		$this->fedex_meter_num	= MODULE_SHIPPING_FEDEX_SMARTPOST_METER_NUM;
    if (defined("SHIPPING_ORIGIN_COUNTRY")) {
      $countries_array = zen_get_countries(SHIPPING_ORIGIN_COUNTRY, true);
      $this->country = $countries_array['countries_iso_code_2'];
    } else {
      $this->country = STORE_ORIGIN_COUNTRY;
    }
    if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_FEDEX_SMARTPOST_ZONE > 0) ) {
      $check_flag = false;
      $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_FEDEX_SMARTPOST_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
      while (!$check->EOF) {
        if ($check->fields['zone_id'] < 1) {
          $check_flag = true;
          break;
        } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
          $check_flag = true;
          break;
        }
        $check->MoveNext();
      }

      if ($check_flag == false) {
        $this->enabled = false;
      }
    }
  }

  //Class Methods

  function quote($method = '') {
	  /* FedEx integration starts */
	  global $db, $shipping_weight, $shipping_num_boxes, $cart, $order;
	  
	  require_once(DIR_WS_INCLUDES . 'library/fedex-common.php5');
    $path_to_wsdl = DIR_WS_MODULES . "shipping/fedexsmartpost/wsdl/RateService_v10.wsdl";
    ini_set("soap.wsdl_cache_enabled", "0");
	  $client = new SoapClient($path_to_wsdl, array('trace' => 1));
	  
    // customer details		  
    $street_address = $order->delivery['street_address'];
    $street_address2 = $order->delivery['suburb'];
    $city = $order->delivery['postcode'];
    $state = zen_get_zone_code($order->delivery['country']['id'], $order->delivery['zone_id'], '');
    if ($state == "QC") $state = "PQ";
    $postcode = str_replace(array(' ', '-'), '', $order->delivery['postcode']);
    $country_id = $order->delivery['country']['iso_code_2'];
      
    $totals = $order->info['subtotal'] = $_SESSION['cart']->show_total();
    $this->_setInsuranceValue($totals);
    
    $request['WebAuthenticationDetail'] = array('UserCredential' =>
                                          array('Key' => $this->fedex_key, 'Password' => $this->fedex_pwd)); // Replace 'XXX' and 'YYY' with FedEx provided credentials 
    $request['ClientDetail'] = array('AccountNumber' => $this->fedex_act_num, 'MeterNumber' => $this->fedex_meter_num);// Replace 'XXX' with your account and meter number
    $request['TransactionDetail'] = array('CustomerTransactionId' => ' *** Rate Request v10 using PHP ***');
    $request['Version'] = array('ServiceId' => 'crs', 'Major' => '10', 'Intermediate' => '0', 'Minor' => '0');
    $request['ReturnTransitAndCommit'] = true;
    $request['RequestedShipment']['DropoffType'] = $this->_setDropOff(); // valid values REGULAR_PICKUP, REQUEST_COURIER, ...
    $request['RequestedShipment']['ShipTimestamp'] = date('c');
    $request['RequestedShipment']['ServiceType'] = 'SMART_POST'; // valid values STANDARD_OVERNIGHT, PRIORITY_OVERNIGHT, FEDEX_GROUND, ...
    $request['RequestedShipment']['SmartPostDetail']['Indicia'] = MODULE_SHIPPING_FEDEX_SMARTPOST_INDICIA;
    if (MODULE_SHIPPING_FEDEX_SMARTPOST_ENDORSEMENT != 'NONE') {
      $request['RequestedShipment']['SmartPostDetail']['AncillaryEndorsement'] = MODULE_SHIPPING_FEDEX_SMARTPOST_ENDORSEMENT;
    }
    if (MODULE_SHIPPING_FEDEX_SMARTPOST_SPECIALSERVICES == 'true') {
      $request['RequestedShipment']['SmartPostDetail']['SpecialServices'] = MODULE_SHIPPING_FEDEX_SMARTPOST_SPECIALSERVICES;
    }
    $request['RequestedShipment']['SmartPostDetail']['HubId'] = (int)MODULE_SHIPPING_FEDEX_SMARTPOST_HUBID;
    $request['RequestedShipment']['PackagingType'] = 'YOUR_PACKAGING'; // valid values FEDEX_BOX, FEDEX_PAK, FEDEX_TUBE, YOUR_PACKAGING, ...
    
	  $request['WebAuthenticationDetail'] = array('UserCredential' => array('Key' => $this->fedex_key, 'Password' => $this->fedex_pwd)); 									  
	  $request['ClientDetail'] = array('AccountNumber' => $this->fedex_act_num, 'MeterNumber' => $this->fedex_meter_num);
    //print_r($request['WebAuthenticationDetail']);
    //print_r($request['ClientDetail']);
    //exit;									  
	  $request['RequestedShipment']['Shipper'] = array('Address' => array(
                                                     'StreetLines' => array(MODULE_SHIPPING_FEDEX_SMARTPOST_ADDRESS_1, MODULE_SHIPPING_FEDEX_SMARTPOST_ADDRESS_2), // Origin details
                                                     'City' => MODULE_SHIPPING_FEDEX_SMARTPOST_CITY,
                                                     'StateOrProvinceCode' => MODULE_SHIPPING_FEDEX_SMARTPOST_STATE,
                                                     'PostalCode' => MODULE_SHIPPING_FEDEX_GROUND_POSTAL,
                                                     'CountryCode' => $this->country));				  
	  $request['RequestedShipment']['Recipient'] = array('Address' => array (
                                                       'StreetLines' => array($street_address, $street_address2), // customer street address
                                                       'City' => $city, //customer city
                                                       'StateOrProvinceCode' => $state, //customer state
                                                       'PostalCode' => $postcode, //customer postcode
                                                       'CountryCode' => $country_id)); //customer county code
	  //print_r($request['RequestedShipment']['Recipient'])	;
	  //exit;									   
	  $request['RequestedShipment']['ShippingChargesPayment'] = array('PaymentType' => 'SENDER',
                                                                    'Payor' => array('AccountNumber' => $this->fedex_act_num, // Replace 'XXX' with payor's account number
                                                                    'CountryCode' => $this->country));
	  $request['RequestedShipment']['RateRequestTypes'] = 'LIST'; 
	  $request['RequestedShipment']['PackageCount'] = $shipping_num_boxes;
	  $request['RequestedShipment']['PackageDetail'] = 'INDIVIDUAL_PACKAGES';
	  $fedex_shipping_weight = $shipping_weight;
    if ($fedex_shipping_weight <= 0) $fedex_shipping_weight = '0.99'; // maximum shipping weight is 0.99LB 
    for ($i=1; $i<=$shipping_num_boxes; $i++) { 	
	    $request['RequestedShipment']['RequestedPackageLineItems'][] = array(
        'Weight' => array(
          'Value' => $fedex_shipping_weight,
          'Units' => MODULE_SHIPPING_FEDEX_SMARTPOST_WEIGHT
        ),
        'GroupPackageCount' => $i
      );
    }
		//print_r($request);
    //exit;																						   
		$response = $client->getRates($request);  
		if ($response -> HighestSeverity != 'FAILURE' && $response -> HighestSeverity != 'ERROR') {
      //echo '<pre>';
      //print_r($response);
      //echo '</pre>';
      //$cost = $response->RateReplyDetails->RatedShipmentDetails[0]->ShipmentRateDetail->TotalNetCharge->Amount;
      $showAccountRates = true;
      if(MODULE_SHIPPING_FEDEX_SMARTPOST_RATES=='LIST') {
        foreach($response->RateReplyDetails->RatedShipmentDetails as $RatedShipmentDetails) {
        	//print_r($RatedShipmentDetails);
          if($RatedShipmentDetails->ShipmentRateDetail->RateType=='PAYOR_LIST_PACKAGE') {
            $cost = $RatedShipmentDetails->ShipmentRateDetail->TotalNetCharge->Amount;
            $cost = (float)round(preg_replace('/[^0-9.]/', '',  $cost), 2);
            if ($cost > 0) $showAccountRates = false;
          }                                              
        }
      }
      if ($showAccountRates) {
        //$cost = $rateReply->RatedShipmentDetails[0]->ShipmentRateDetail->TotalNetCharge->Amount;
        $cost = $response->RateReplyDetails->RatedShipmentDetails[0]->ShipmentRateDetail->TotalNetCharge->Amount;
        $cost = (float)round(preg_replace('/[^0-9.]/', '',  $cost), 2);
      }
      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_FEDEX_SMARTPOST_TEXT_TITLE . $show_box_weight,
                            'methods' => array(array('id' => $this->code,
                                                     'title' => MODULE_SHIPPING_FEDEX_SMARTPOST_TEXT_TITLE,
                                                     'cost' => $cost)));
      if ($this->tax_class > 0) {
        $this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      } 
		} else {
			$message = 'Error in processing transaction.<br /><br />'; 
			foreach ($response -> Notifications as $notification) {           
				if(is_array($response -> Notifications)) {              
          $message .= $notification -> Severity;
          $message .= ': ';           
          $message .= $notification -> Message . '<br />';
				} else {
					$message .= $notification . '<br />';
				}
			}
      $this->quotes = array('module' => $this->title,
                            'error'  => $message);
		}
    if (zen_not_null($this->icon)) $this->quotes['icon'] = zen_image($this->icon, $this->title, '', '', 'style="vertical-align:middle;"');
    return $this->quotes;
  }

  function _setInsuranceValue($order_amount){
    if ($order_amount > MODULE_SHIPPING_FEDEX_SMARTPOST_INSURE) {
      $this->insurance = sprintf("%01.2f", $order_amount);
    } else {
      $this->insurance = 0;
    }
  }
  
  function _setDropOff() {
    switch(MODULE_SHIPPING_FEDEX_SMARTPOST_DROPOFF) {
      case '1':
        return 'REGULAR_PICKUP';
        break;
      case '2':
        return 'REQUEST_COURIER';
        break;
      case '3':
        return 'DROP_BOX';
        break;
      case '4':
        return 'BUSINESS_SERVICE_CENTER';
        break;
      case '5':
        return 'STATION';
        break;
    }
  }

  function check(){
    global $db;
	  if(!isset($this->_check)){
      $check_query  = $db->Execute("SELECT configuration_value FROM ". TABLE_CONFIGURATION ." WHERE configuration_key = 'MODULE_SHIPPING_FEDEX_SMARTPOST_STATUS'");
      $this->_check = $check_query->RecordCount();      
      if ($this->_check && defined('MODULE_SHIPPING_FEDEX_SMARTPOST_STATUS')) {
        $this->version = MODULE_SHIPPING_FEDEX_SMARTPOST_STATUS;
        while ($this->version != '1.2.6') {
          switch($this->version) {
            case '1.2.0':
              // perform upgrade
              $db->Execute("replace into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Version Installed', 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION', '1.2.1', '', '6', '0', now())");
              $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('FedEx Rates','MODULE_SHIPPING_FEDEX_SMARTPOST_RATES','LIST','FedEx Rates (LIST = FedEx default rates, ACCOUNT = Your discounted rates)','6','0','zen_cfg_select_option(array(\'LIST\',\'ACCOUNT\'),',now())");
              $messageStack->add('Updated FedEx SmartPost to v1.2.0', 'success');
              $this->version = '1.2.0';
              break;
            case '1.2.1':
              // perform upgrade
              $db->Execute("replace into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Version Installed', 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION', '1.2.2', '', '6', '0', now())");
              $messageStack->add('Updated FedEx SmartPost to v1.2.1', 'success');
              $this->version = '1.2.2';
              break; 
            case '1.2.2':
              // perform upgrade
              $db->Execute("replace into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Version Installed', 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION', '1.2.3', '', '6', '0', now())");
              $messageStack->add('Updated FedEx SmartPost to v1.2.3', 'success');
              $this->version = '1.2.3';
              break;
            case '1.2.3':
              // perform upgrade
              $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_SHIPPING_FEDEX_SMARTPOST_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', '6', '25', 'zen_get_tax_class_title', 'zen_cfg_pull_down_tax_classes(', now())");
              $db->Execute("replace into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Version Installed', 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION', '1.2.4', '', '6', '0', now())");    
              $messageStack->add('Updated FedEx SmartPost to v1.2.4', 'success');
              $this->version = '1.2.4';
              break;
            case '1.2.4':
              // perform upgrade
              $db->Execute("replace into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Version Installed', 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION', '1.2.5', '', '6', '0', now())");    
              $messageStack->add('Updated FedEx SmartPost to v1.2.5', 'success');
              $this->version = '1.2.5';
              break;
            case '1.2.5':
              // perform upgrade
              $db->Execute("replace into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Version Installed', 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION', '1.2.6', '', '6', '0', now())");    
              $messageStack->add('Updated FedEx SmartPost to v1.2.6', 'success');
              $this->version = '1.2.6';
              break;                                                                                                     
            default:
              $this->version = '1.2.6';
              // break all the loops
              break 2;      
          }
        }
	    }
    }
	  return $this->_check;
  }

  function install() {
    global $db;
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Enable FedEx SmartPost','MODULE_SHIPPING_FEDEX_SMARTPOST_STATUS','true','Do you want to offer FedEx shipping?','6','0','zen_cfg_select_option(array(\'true\',\'false\'),',now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Version Installed', 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION', '1.2.6', '', '6', '0', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('FedEx Key', 'MODULE_SHIPPING_FEDEX_SMARTPOST_KEY', 'CC9uiY62KI10mPGn', 'Enter FedEx Web Services Key', '6', '1', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('FedEx Password', 'MODULE_SHIPPING_FEDEX_SMARTPOST_PWD', 'xJK8dnC5PCJzrWETEBtIovDLC', 'Enter FedEx Web Services Password', '6', '2', now())");	  
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('FedEx Account Number', 'MODULE_SHIPPING_FEDEX_SMARTPOST_ACT_NUM', '510087402', 'Enter FedEx Account Number', '6', '3', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('FedEx Meter Number', 'MODULE_SHIPPING_FEDEX_SMARTPOST_METER_NUM', '118503951', 'Enter FedEx Meter Number', '6', '4', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Weight Units', 'MODULE_SHIPPING_FEDEX_SMARTPOST_WEIGHT', 'LB', 'Weight Units:', '6', '10', 'zen_cfg_select_option(array(\'LB\', \'KG\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('First line of street address', 'MODULE_SHIPPING_FEDEX_SMARTPOST_ADDRESS_1', '', 'Enter the first line of your ship-from street address, required', '6', '20', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Second line of street address', 'MODULE_SHIPPING_FEDEX_SMARTPOST_ADDRESS_2', '', 'Enter the second line of your ship-from street address, leave blank if you do not need to specify a second line', '6', '21', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('City name', 'MODULE_SHIPPING_FEDEX_SMARTPOST_CITY', '', 'Enter the city name for the ship-from street address, required', '6', '22', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('State or Province name', 'MODULE_SHIPPING_FEDEX_SMARTPOST_STATE', '', 'Enter the 2 letter state or province name for the ship-from street address, required for Canada and US', '6', '23', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Postal code', 'MODULE_SHIPPING_FEDEX_SMARTPOST_POSTAL', '', 'Enter the postal code for the ship-from street address, required', '6', '24', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Phone number', 'MODULE_SHIPPING_FEDEX_SMARTPOST_PHONE', '', 'Enter a contact phone number for your company, required', '6', '25', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('HubId', 'MODULE_SHIPPING_FEDEX_SMARTPOST_HUBID', '5531', 'Enter the HubId for SmartPost (Use 5531 for testing)', '6', '30', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Indicia', 'MODULE_SHIPPING_FEDEX_SMARTPOST_INDICIA', 'PARCEL_SELECT', 'Specify the Indicia Type', '6', '30', 'zen_cfg_select_option(array(\'MEDIA_MAIL\',\'PARCEL_SELECT\',\'PRESORTED_BOUND_PRINTED_MATTER\',\'PRESORTED_STANDARD\'),', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Ancillary Endorsement', 'MODULE_SHIPPING_FEDEX_SMARTPOST_ENDORSEMENT', 'NONE', 'Specify an endorsement type', '6', '30', 'zen_cfg_select_option(array(\'NONE\',\'ADDRESS_CORRECTION\',\'CARRIER_LEAVE_IF_NO_RESPONSE\',\'CHANGE_SERVICE\',\'FORWARDING_SERVICE\',\'RETURN_SERVICE\'),', now())");    
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Special Services', 'MODULE_SHIPPING_FEDEX_SMARTPOST_SPECIALSERVICES', 'false', 'Add delivery confirmation?', '6', '30', 'zen_cfg_select_option(array(\'true\',\'false\'),', now())");    
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Drop off type', 'MODULE_SHIPPING_FEDEX_SMARTPOST_DROPOFF', '1', 'Dropoff type (1 = Regular pickup, 2 = request courier, 3 = drop box, 4 = drop at BSC, 5 = drop at station)?', '6', '30', 'zen_cfg_select_option(array(\'1\',\'2\',\'3\',\'4\',\'5\'),', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Currency Code', 'MODULE_SHIPPING_FEDEX_SMARTPOST_CURRENCY', 'USD', 'Enter 3 digit currency code (default = USD)', '6', '30', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('FedEx Rates','MODULE_SHIPPING_FEDEX_SMARTPOST_RATES','LIST','FedEx Rates (LIST = FedEx default rates, ACCOUNT = Your discounted rates)','6','0','zen_cfg_select_option(array(\'LIST\',\'ACCOUNT\'),',now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Shipping Zone', 'MODULE_SHIPPING_FEDEX_SMARTPOST_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', '6', '98', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_SHIPPING_FEDEX_SMARTPOST_SORT_ORDER', '0', 'Sort order of display.', '6', '99', now())"); 
  }

  function remove() {
    global $db;
	  $db->Execute("DELETE FROM ". TABLE_CONFIGURATION ." WHERE configuration_key in ('". implode("','",$this->keys()). "')");
  }

  function keys() {
	  return array('MODULE_SHIPPING_FEDEX_SMARTPOST_STATUS',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_VERSION',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_KEY',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_PWD',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_ACT_NUM',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_METER_NUM',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_WEIGHT',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_ADDRESS_1',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_ADDRESS_2',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_CITY',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_STATE',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_POSTAL',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_PHONE',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_DROPOFF',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_CURRENCY',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_HUBID',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_INDICIA',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_SPECIALSERVICES',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_ENDORSEMENT',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_RATES',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_TAX_CLASS',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_SORT_ORDER',
                 'MODULE_SHIPPING_FEDEX_SMARTPOST_ZONE'
                 );
  }
}
?>